/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignRecurringConfigCanaryConfig type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignRecurringConfigCanaryConfig{}

// CampaignRecurringConfigCanaryConfig struct for CampaignRecurringConfigCanaryConfig
type CampaignRecurringConfigCanaryConfig struct {
	Amount *int32 `json:"amount,omitempty"`
	ManualResume *bool `json:"manual_resume,omitempty"`
}

// NewCampaignRecurringConfigCanaryConfig instantiates a new CampaignRecurringConfigCanaryConfig object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignRecurringConfigCanaryConfig() *CampaignRecurringConfigCanaryConfig {
	this := CampaignRecurringConfigCanaryConfig{}
	return &this
}

// NewCampaignRecurringConfigCanaryConfigWithDefaults instantiates a new CampaignRecurringConfigCanaryConfig object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignRecurringConfigCanaryConfigWithDefaults() *CampaignRecurringConfigCanaryConfig {
	this := CampaignRecurringConfigCanaryConfig{}
	return &this
}

// GetAmount returns the Amount field value if set, zero value otherwise.
func (o *CampaignRecurringConfigCanaryConfig) GetAmount() int32 {
	if o == nil || IsNil(o.Amount) {
		var ret int32
		return ret
	}
	return *o.Amount
}

// GetAmountOk returns a tuple with the Amount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfigCanaryConfig) GetAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.Amount) {
		return nil, false
	}
	return o.Amount, true
}

// HasAmount returns a boolean if a field has been set.
func (o *CampaignRecurringConfigCanaryConfig) HasAmount() bool {
	if o != nil && !IsNil(o.Amount) {
		return true
	}

	return false
}

// SetAmount gets a reference to the given int32 and assigns it to the Amount field.
func (o *CampaignRecurringConfigCanaryConfig) SetAmount(v int32) {
	o.Amount = &v
}

// GetManualResume returns the ManualResume field value if set, zero value otherwise.
func (o *CampaignRecurringConfigCanaryConfig) GetManualResume() bool {
	if o == nil || IsNil(o.ManualResume) {
		var ret bool
		return ret
	}
	return *o.ManualResume
}

// GetManualResumeOk returns a tuple with the ManualResume field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignRecurringConfigCanaryConfig) GetManualResumeOk() (*bool, bool) {
	if o == nil || IsNil(o.ManualResume) {
		return nil, false
	}
	return o.ManualResume, true
}

// HasManualResume returns a boolean if a field has been set.
func (o *CampaignRecurringConfigCanaryConfig) HasManualResume() bool {
	if o != nil && !IsNil(o.ManualResume) {
		return true
	}

	return false
}

// SetManualResume gets a reference to the given bool and assigns it to the ManualResume field.
func (o *CampaignRecurringConfigCanaryConfig) SetManualResume(v bool) {
	o.ManualResume = &v
}

func (o CampaignRecurringConfigCanaryConfig) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignRecurringConfigCanaryConfig) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Amount) {
		toSerialize["amount"] = o.Amount
	}
	if !IsNil(o.ManualResume) {
		toSerialize["manual_resume"] = o.ManualResume
	}
	return toSerialize, nil
}

type NullableCampaignRecurringConfigCanaryConfig struct {
	value *CampaignRecurringConfigCanaryConfig
	isSet bool
}

func (v NullableCampaignRecurringConfigCanaryConfig) Get() *CampaignRecurringConfigCanaryConfig {
	return v.value
}

func (v *NullableCampaignRecurringConfigCanaryConfig) Set(val *CampaignRecurringConfigCanaryConfig) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignRecurringConfigCanaryConfig) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignRecurringConfigCanaryConfig) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignRecurringConfigCanaryConfig(val *CampaignRecurringConfigCanaryConfig) *NullableCampaignRecurringConfigCanaryConfig {
	return &NullableCampaignRecurringConfigCanaryConfig{value: val, isSet: true}
}

func (v NullableCampaignRecurringConfigCanaryConfig) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignRecurringConfigCanaryConfig) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


